﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Configuration;
using System.Web.Http;
using System.Web.Mvc;
using Syncfusion.EJ.ReportViewer;
using Syncfusion.Reports.EJ;
using System.Data;
using System.Data.SqlClient;

namespace ReportViewerSampleASP.NetMVC.Controllers
{
    public class ReportAPIController : ApiController, IReportController
    {
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            return ReportHelper.ProcessReport(jsonResult, this);
        }
        [System.Web.Http.ActionName("GetResource")]
        [System.Web.Http.AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
              reportOption.ReportModel.DataSources.Clear();
              reportOption.ReportModel.DataSources.Add(new ReportDataSource { Name = "DataSet1", Value = this.GetDataTable("SELECT Top 2000 B1.* FROM [AdventureWorks].[Production].[BillOfMaterials] as B1 CROSS JOIN [AdventureWorks].[Production].[BillOfMaterials] as B2", "Data Source=mvc.syncfusion.com;Initial Catalog=AdventureWorks;User Id=ssrs1;Password=RDLReport1;") });
        }
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
        }


        public DataTable GetDataTable(string querystr, string connection)
        {
            string query = querystr;
            DataTable dt = new DataTable();

            using (SqlConnection sqlConn = new SqlConnection(connection))
            using (SqlCommand cmd = new SqlCommand(string.Format(query), sqlConn))
            {
                sqlConn.Open();

                using (SqlDataReader reader = cmd.ExecuteReader())
                {
                    dt.Load(reader);
                }
                return dt;
            }
        }
    }
}