﻿using Syncfusion.EJ.ReportViewer;
using Syncfusion.Reports.EJ;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;
using System.Collections;
using System.Data;
using System.Reflection;

namespace MVCSampleBrowser
{
    public class SSRSReportController : ApiController, IReportController
    {
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            return ReportHelper.ProcessReport(jsonResult, this);
        }

        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            if (reportOption.ReportModel.ReportPath.Contains("InvoiceTemplate"))
            {
                reportOption.ReportModel.ReportServerCredential = new System.Net.NetworkCredential("ssrs", "RDLReport1");
                reportOption.ReportModel.DataSourceCredentials.Add(new DataSourceCredentials("NorthWindIO", "ssrs1", "RDLReport1"));
            }
        }

        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
            //List<ReportParameter> _params = new List<ReportParameter>();
            //ReportParameter _para = new ReportParameter();
            //_para.Name = "InvoiceID";
            //_para.Labels.Add("InvoiceID");
            //_para.Values.Add("10251");
            //_params.Add(_para);
            //reportOption.ReportModel.Parameters = _params;
        }
    }
}